SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

DECLARE @Major int, @Minor int, @Patch int, @Installed DateTime, @Prereqs int

Set @Major = 3;
Set @Minor = 1;
Set @Patch = 24;

Select @Prereqs = isnull(Count(InstallDate),0)  from cs_SchemaVersion where Major=@Major and Minor=@Minor and Patch<@Patch

Select @Installed = InstallDate  from cs_SchemaVersion where Major=@Major and Minor=@Minor and Patch=@Patch

If(@Installed is null AND @Prereqs = @Patch)
	BEGIN
--## Schema Patch ##

EXECUTE sp_executesql N'
CREATE TABLE [dbo].[cs_ApiKeys](
	[ApiKeyID] [int] IDENTITY(1,1) NOT NULL,
	[UserID] [int] NOT NULL,
	[Value] [char](8) NOT NULL,
	[Name] [varchar](50) NOT NULL,
	[DateCreated] [datetime] NOT NULL CONSTRAINT [DF_cs_ApiKeys_DateCreated]  DEFAULT (getdate()),
	[Enabled] [bit] NOT NULL CONSTRAINT [DF_cs_ApiKeys_Enabled]  DEFAULT ((1)),
 CONSTRAINT [PK_cs_ApiKeys] PRIMARY KEY CLUSTERED 
(
	[ApiKeyID] ASC
)) ON [PRIMARY]'

EXECUTE sp_executesql N'CREATE NONCLUSTERED INDEX [IX_cs_ApiKeys_UserID] ON [dbo].[cs_ApiKeys] ([UserID]) WITH FILLFACTOR = 90 ON [PRIMARY]'
EXECUTE sp_executesql N'CREATE UNIQUE NONCLUSTERED INDEX [IX_cs_ApiKeys_Value] ON [dbo].[cs_ApiKeys] ([Value])'

--## END Schema Patch ##
Insert into cs_SchemaVersion(Major, Minor, Patch, InstallDate) values (@Major, @Minor, @Patch, GetDate())

Print 'Schema Patch v' + Convert(Varchar(2),@Major) + '.' + Convert(Varchar(2),@Minor) + '.' +  Convert(Varchar(3),@Patch) + ' was applied successfully '

	END
ELSE IF(@Installed is not null)
	BEGIN
Print 'Schema Patch v' + Convert(Varchar(2),@Major) + '.' + Convert(Varchar(2),@Minor) + '.' +  Convert(Varchar(3),@Patch) + ' was already applied on ' + Convert(varchar(50), @Installed)  
	END 
ELSE
	BEGIN
Print 'The patch could not be applied because your current schema is missing previous updates (Schema Patch v' + Convert(Varchar(2),@Major) + '.' + Convert(Varchar(2),@Minor) + '.' +  Convert(Varchar(3),@Patch) + ')' 
	END 
